---
title: Build your own Jekyll blog
description: Overview of content I like to share when coaching

---
## Intro

The content here is focused on build a static website such as a blog, using Jekyll. I want to describe available features and a path of how to build them.

This post is for someone who has at least a bit of coding experience and wants to start coding their own blog or improve their existing blog.

I plan to use this list as a reference when coaching people online - whether in a blog post, a face-to-face online chat or even a live-streaming coding session. I am going to focus on topics and broad strokes here. You'll get more details out of chatting to me directly.

I have a profile on Jekyll Forums - you can message me there directly and I'll be happy to help.

* [talk.jekyll.com/@MichaelCurrin ](https://talk.jekyllrb.com/u/michaelcurrin/)

## Topics

I'll phrase these as questions to answer or use-cases to explain.

* Basics
  * What is a static site?
  * What are Jekyll and Ruby?
  * What is GitHub Pages? How does it work - deploys, cost, custom domain?
* Links to external repos that are hosted as static sites (links are on GitHub in the top right)
  * Minimal sites
    * [https://github.com/MichaelCurrin/simplest-jekyll](https://github.com/MichaelCurrin/simplest-jekyll "https://github.com/MichaelCurrin/simplest-jekyll")
    * [https://github.com/MichaelCurrin/themeless-jekyll-quickstart](https://github.com/MichaelCurrin/themeless-jekyll-quickstart "https://github.com/MichaelCurrin/themeless-jekyll-quickstart")
    * [https://github.com/MichaelCurrin/jekyll-themed-site-quickstart](https://github.com/MichaelCurrin/jekyll-themed-site-quickstart "https://github.com/MichaelCurrin/jekyll-themed-site-quickstart")
  * Blogs
    * [github.com/MichaelCurrin/coding-blog](https://github.com/MichaelCurrin/coding-blog "https://github.com/MichaelCurrin/coding-blog")
    * [github.com/MichaelCurrin/jekyll-blog-demo](https://github.com/MichaelCurrin/jekyll-blog-demo "https://github.com/MichaelCurrin/jekyll-blog-demo")
  * Developer portfolios
    * [MichaelCurrin/my-github-projects](https://github.com/MichaelCurrin/my-github-projects "https://github.com/MichaelCurrin/my-github-projects")
    * [MichaelCurrin.github.io/](https://MichaelCurrin.github.io/)
  * Pull in external data live
    * [MichaelCurrin/gist-viewer](https://github.com/MichaelCurrin/gist-viewer "https://github.com/MichaelCurrin/gist-viewer")
  * Languages and tools
    * Python - [https://github.com/MichaelCurrin/mkdocs-quickstart](https://github.com/MichaelCurrin/mkdocs-quickstart "https://github.com/MichaelCurrin/mkdocs-quickstart")
    * React - [https://github.com/MichaelCurrin/react-quickstart](https://github.com/MichaelCurrin/react-quickstart "https://github.com/MichaelCurrin/react-quickstart")
    * Vue -  [https://github.com/MichaelCurrin/vue-quickstart](https://github.com/MichaelCurrin/vue-quickstart "https://github.com/MichaelCurrin/vue-quickstart")
    * VuePress - [https://github.com/MichaelCurrin/vuepress-quickstart](https://github.com/MichaelCurrin/vuepress-quickstart "https://github.com/MichaelCurrin/vuepress-quickstart") (no live site provided yet)
  * Businesses and people
    * A writer, musician and photographer - [github.com/MichaelCurrin/toast-coetzer](https://github.com/MichaelCurrin/toast-coetzer "https://github.com/MichaelCurrin/toast-coetzer")
    * Artists Portfolio template - [github.com/MichaelCurrin/artists-portfolio](https://github.com/MichaelCurrin/artists-portfolio "https://github.com/MichaelCurrin/artists-portfolio")
  * Collect and teach content - [github.com/MichaelCurrin/code-cookbook](https://github.com/MichaelCurrin/code-cookbook "https://github.com/MichaelCurrin/code-cookbook")
  * A toy or game
    * [https://github.com/MichaelCurrin/food-blender-site](https://github.com/MichaelCurrin/food-blender-site "https://github.com/MichaelCurrin/food-blender-site") [https://michaelcurrin.github.io/food-blender-site/](https://michaelcurrin.github.io/food-blender-site/ "https://michaelcurrin.github.io/food-blender-site/")
* Customize
  * Theme [https://github.com/MichaelCurrin/jekyll-theme-quickstart](https://github.com/MichaelCurrin/jekyll-theme-quickstart "https://github.com/MichaelCurrin/jekyll-theme-quickstart")
  * Plugin
    * [https://github.com/MichaelCurrin/jekyll-keys-filter](https://github.com/MichaelCurrin/jekyll-keys-filter "https://github.com/MichaelCurrin/jekyll-keys-filter")
    * [https://github.com/MichaelCurrin/liquid-thousands-separated-filter](https://github.com/MichaelCurrin/liquid-thousands-separated-filter "https://github.com/MichaelCurrin/liquid-thousands-separated-filter")
* Bringing your blog to life
  * Add an image gallery
  * Build your own theme?
* Managing a site as a business
  * How do I get a custom domain and use it?
  * How do I get my visitors to contact me?
  * How do I track my visitors?
    * Google Analtics
      * GDR compliant. Users are kept anonymous. Just down turn on advanced tracking settings in admin unless you know what you are doing.
    * Adobe Analytics
  * How do I add an online shopping integration?
  * How do I keep my repo private? 
    * GitHub Actions
    * Netlify