---
title: Coding and music
description: ''
tags: music
---
## How to write music with code

### Live coding topic

* [Live coding](https://en.wikipedia.org/wiki/Live_coding "https://en.wikipedia.org/wiki/Live_coding") on Wikipedia

That includes impromptu musical performances with code.

### Sonic Pi for writing music with code

Try out Sonic Pi - a Ruby-based programming language that plays notes and music based on the code you write.

* [sonic-pi.net](https://sonic-pi.net/)

  > Sonic Pi is a code-based music creation and performance tool.

It can be used for a live performance, as it constantly loops and responds to the changes you make.

Download for Window, macOS or Raspberry Pi.

### ChucK

* [chuck.cs.princeton.edu](https://chuck.cs.princeton.edu/ "https://chuck.cs.princeton.edu/")

  > ChucK : Strongly-timed, Concurrent, and On-the-fly
* Blog post as an intro to ChuckD
  * [Live coding with ChucK on Ubuntu](http://giovanni.curlybrackets.it/2013/02/20/live-coding-with-chuck-on-ubuntu.html )

This is relies on the JACK, covered below.

### JACK - Jack Audio Connection Kit

A tool for mixing sound and recordings.

* [jackaudio.org](https://jackaudio.org/ "https://jackaudio.org/")

It can be installed on Ubuntu as:

    sudo apt-get install jackd

There are plenty of resources listed here including live programming:

* [jackaudio.org/applications/](https://jackaudio.org/applications/ "https://jackaudio.org/applications/")

## Music composed by computers

### Mubert

I found this tool which provides AI-generated music based on human-made samples. Their mobile app is great. I just found the genres too limiting based on my tastes but there are plenty to choose from.

* [mubert.com](https://mubert.com/)

  > Smart music powered by AI

Here is their API page. [mubert.com/api/](https://mubert.com/api/ "https://mubert.com/api/")

### TEDx talk - The world's ugliest music

Watch this _TEDxMIA_ talk on YouTube:

* [The world's ugliest music](https://www.youtube.com/watch?v=RENk9PK06AQ) by Scott Rickard

A song was composed by an algorithm which made sure there are no repeats or patterns in time between the notes or in pitch changes. It's not just random - its deliberately pattern free.

The result is music which is ugly to us. As we look for a pattern but there is none. It reminds me of some jazz music I've heard, but this is way worse.

A pianist performs the piece at the end.
