---
title: AI art tools in 2023
description: 'Free AI tools to try now for making art'
tags: ai technology gpt art
cover_img_path: assets/images/posts/ai-art-tools-text.jpg
---

_Banner image made with NightCafe, originally posted [here](https://creator.nightcafe.studio/creation/1hod8e4xUEqr4mcvziD2)._

## Dall-E

- [dalle3.org](https://www.dalle3.org/)

Dall-E is one of the famous models used at the moment for text-to-image AI.

On the Dall-E 3 website itself, you can create art with the model. I do not recommended because of limited credits that don't top up automatically, and you get far superior quality using Dall-E 3 in Bing Image Creator (covered next).

## Bing Image Creator

- [bing.com/images/create](https://www.bing.com/images/create)

This uses Dall-E 3. This is the best beginner-friendly tool with low customization but impressive results. You can make an unlimited number of images. But after your quota after lightning/speed tokens is done for the day, your images are created much slower like every 30s or 5min, rather than within a 5 seconds.

Images are only 1024x1024 pixels, cannot be upsized, and you can't see your history of images beyond your recent ones (unless you know the URL).

On the homepage, you can see the popular creations by other users and use or tweak their prompts if you want, so that is great for learning.

## NightCafe Studio

- [creator.nightcafe.studio/](https://creator.nightcafe.studio/)

This gives more control like output size, number of images, and negative keywords.

There are many models to choose from including popular ones like Dall-E (2 is the latest) and Stable Diffusion (e.g. SDXL as a higher-resolution version).

Your creations can be kept private or published so other uses can discover them.

You get to interact with other users, like on Instagram. You can reuse the prompts other users if they are open.

You can control whether your prompt is public or not. You can upsize your image up to 8000x8000 pixels, then download it, if you want to print or sell it, with no copyright restrictions.

Images cost credits to make, and using more complex models and settings costs more credits. You get 5 credits a day just for logging in and 3 points everytime you share to Instagram (with a link back to your creation), though with a max allowed for the day. There is also an older Stable Diffusion model which costs zero credits if you want to experiment with that, until it gets deprecated.

Here is my profile - [@MyKale](https://creator.nightcafe.studio/u/MyKale).


## Leonardo AI

- [leonardo.ai](https://leonardo.ai)

Originally for game development, this gives impressive quality and control. And you get enough free credits a day to create a couple of rounds of 4 images at a time. You can also use the prompts of other users if you like their images.

And you can do advanced features like extending the background, background removal, upsizing, and masking. There's also a neat tool for creating longer text prompts based on a short prompt, though a tool like ChatGPT is already capable of doing this well if you know how.


## Bing Chat

- [bing.com/search?q=Bing+AI](https://www.bing.com/search?q=Bing+AI&showconv=1&FORM=hpcodx)

This just uses Bing Image Creator internally. But it is far more interactive using chat view or in the Edge sidebar. So the AI gives you some hints of things you can do to improve the image. You can even ask the AI to take a basic image prompt and generate more complex ones and generate the images immediately. You can even get it to create multiple creations at once with slightly different prompts, based on a single request you give it.

Also, ChatGPT Plus just added image creation to text chat too, matching Bing. But that is only on the paid version.
